#include <bits/stdc++.h>

using namespace std;

const int Inf = 1e9;

int get_min_pow(int s) {
    int k = 1;
    while (k < s) {
        k *= 2;
    }
    return k;
}

struct Tree {
    vector<long long> tree;
    int arr_size;
    int k;
    Tree(int s=1) {
        arr_size = s;
        k = get_min_pow(s);
        tree.resize(2 * k, Inf);
    }
    void upd(int pos, int val);
    void full_upd(int v, int lv, int rv, int pos, int val);
    int get_min(int l, int r);
    int full_get_min(int v, int lv, int rv, int l, int r);
};

int Tree::full_get_min(int v, int lv, int rv, int l, int r) {
    if (lv == l && rv == r) {
        return tree[v];
    }
    int m = (lv + rv) / 2;
    if (l > m) {
        return full_get_min(v * 2 + 1, m + 1, rv, l, r);
    }
    if (r <= m) {
        return full_get_min(v * 2, lv, m, l, r);
    }
    return min(full_get_min(v * 2, lv, m, l, m), full_get_min(v * 2 + 1, m + 1, rv, m + 1, r));
}

int Tree::get_min(int l, int r) {
    return full_get_min(1, 0, k - 1, l, r);
}

void Tree::full_upd(int v, int lv, int rv, int pos, int val) {
    if (lv == rv) {
        tree[v] = val;
        return;
    }
    int m = (lv + rv) / 2;
    if (m < pos) {
        full_upd(v * 2 + 1, m + 1, rv, pos, val);
    }
    else {
        full_upd(v * 2, lv, m, pos, val);
    }
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

void Tree::upd(int pos, int val) {
    full_upd(1, 0, k - 1, pos, val);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(12);
    int n, m;
    cin >> n;
    cin >> m;
    int dp[n][m];
    Tree d_o[m];
    pair<int, int> data[m];
    int sizes[m];
    for (int i = 0; i < m; ++i) {
        d_o[i] = Tree(n);
        int a, b;
        cin >> a;
        cin >> b;
        data[i] = {a - 1, b - 1};
        sizes[i] = b - a;
    }
    for (int i = 0; i < n; ++i) {
        if (i + sizes[0] < n) {
            dp[i][0] = abs(data[0].first - i);
        }
        else {
            dp[i][0] = Inf;
        }
        int add = 0;
        if (m > 1) {
            if (i + sizes[1] < n) {
                add = min(min(abs(data[1].first - i), abs(data[1].first - i - sizes[0])), min(abs(data[1].second - i), abs(data[1].second - i - sizes[0])));
            }
            else {
                add = Inf;
            }
        }
        d_o[0].upd(i, dp[i][0] + add);
        //cout << dp[i][0] << ' ';
    }
    //cout << endl;
    for (int j = 1; j < m; ++j) {
        for (int i = 0; i < n; ++i) {
            if (i + sizes[j] >= n) {
                dp[i][j] = Inf;
            }
            else {
                int s = max(i - sizes[j - 1], 0);
                int f = i + sizes[j] - 1;
                int x = d_o[j - 1].get_min(s, f);
                dp[i][j] = x;
                //cout << "{" << s << ", " << f << ", " << x << "} ";
            }
            int add = 0;
            if (j != m - 1) {
                if (i + sizes[j + 1] < n) {
                    add = min(min(abs(data[j + 1].first - i), abs(data[j + 1].first - i - sizes[j])), min(abs(data[j + 1].second - i), abs(data[j + 1].second - i - sizes[j])));
                }
                else {
                    add = Inf;
                }
            }
            d_o[j].upd(i, dp[i][j] + add);
            //cout << dp[i][j] << ' ';
        }
        //cout << endl;
    }

    /*for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cout << d_o[i].get_min(j, j) << ' ';
        }
        cout << endl;
    }*/
    int minim = Inf;
    for (int i = 0; i < n; ++i) {
        minim = min(minim, dp[i][m - 1]);
    }
    cout << minim << endl;
    return 0;
}
