#include <bits/stdc++.h>

using namespace std;

const int Inf = 1e9;
const long long INF = 1e18;
const long long zero = 0;

long long get_min_pow(long long s) {
    long long k = 1;
    while (k < s) {
        k *= 2;
    }
    return k;
}

struct Tree {
    vector<long long> tree;
    vector<long long> data;
    long long arr_size;
    long long k;
    Tree(long long s=1) {
        arr_size = s;
        k = get_min_pow(s);
        tree.resize(2 * k, INF);
        data.resize(k, INF);
    }
    void upd(long long pos, long long val);
    void full_upd(long long v, long long lv, long long rv, long long pos, long long val);
    long long get_min(long long l, long long r);
    long long full_get_min(long long v, long long lv, long long rv, long long l, long long r);
    void full_build(long long v, long long lv, long long rv);
    void build();
};

void Tree::full_build(long long v, long long lv, long long rv) {
    if (lv == rv) {
        tree[v] = data[lv];
        return;
    }
    int m = (lv + rv) / 2;
    full_build(v * 2, lv, m);
    full_build(v * 2 + 1, m + 1, rv);
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

void Tree::build() {
    full_build(1, 0, k - 1);
}

long long Tree::full_get_min(long long v, long long lv, long long rv, long long l, long long r) {
    if (lv == l && rv == r) {
        return tree[v];
    }
    long long m = (lv + rv) / 2;
    if (l > m) {
        return full_get_min(v * 2 + 1, m + 1, rv, l, r);
    }
    if (r <= m) {
        return full_get_min(v * 2, lv, m, l, r);
    }
    return min(full_get_min(v * 2, lv, m, l, m), full_get_min(v * 2 + 1, m + 1, rv, m + 1, r));
}

long long Tree::get_min(long long l, long long r) {
    return full_get_min(1, 0, k - 1, l, r);
}

void Tree::full_upd(long long v, long long lv, long long rv, long long pos, long long val) {
    if (lv == rv) {
        tree[v] = val;
        return;
    }
    long long m = (lv + rv) / 2;
    if (m < pos) {
        full_upd(v * 2 + 1, m + 1, rv, pos, val);
    }
    else {
        full_upd(v * 2, lv, m, pos, val);
    }
    tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
}

void Tree::upd(long long pos, long long val) {
    full_upd(1, 0, k - 1, pos, val);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision(12);
    long long n, m;
    cin >> n;
    cin >> m;
    long long dp[n][m];
    Tree d_o[m];
    pair<long long, long long> data[m];
    long long sizes[m];
    for (long long i = 0; i < m; ++i) {
        d_o[i] = Tree(n);
        long long a, b;
        cin >> a;
        cin >> b;
        data[i] = {a - 1, b - 1};
        sizes[i] = b - a;
    }
    for (long long i = 0; i < n; ++i) {
        if (i + sizes[0] < n) {
            dp[i][0] = abs(data[0].first - i);
        }
        else {
            dp[i][0] = INF;
        }
        long long add = 0;
        if (m > 1) {
            if (i + sizes[1] < n) {
                add = min(min(abs(data[1].first - i), abs(data[1].first - i - sizes[0])), min(abs(data[1].second - i), abs(data[1].second - i - sizes[0])));
            }
            else {
                add = INF;
            }
        }
        //d_o[0].upd(i, dp[i][0] + add);
        d_o[0].data[i] = dp[i][0] + add;
        //cout << dp[i][0] << ' ';
    }
    d_o[0].build();
    //cout << endl;
    for (long long j = 1; j < m; ++j) {
        for (long long i = 0; i < n; ++i) {
            if (i + sizes[j] >= n) {
                dp[i][j] = INF;
            }
            else {
                long long s = max(i - sizes[j - 1], zero);
                long long f = i + sizes[j] - 1;
                long long x = d_o[j - 1].get_min(s, f);
                dp[i][j] = x;
                //cout << "{" << s << ", " << f << ", " << x << "} ";
            }
            long long add = 0;
            if (j != m - 1) {
                if (i + sizes[j + 1] < n) {
                    add = min(min(abs(data[j + 1].first - i), abs(data[j + 1].first - i - sizes[j])), min(abs(data[j + 1].second - i), abs(data[j + 1].second - i - sizes[j])));
                }
                else {
                    add = INF;
                }
            }
            //d_o[j].upd(i, dp[i][j] + add);
            d_o[j].data[i] = dp[i][j] + add;
            //cout << dp[i][j] << ' ';
        }
        //cout << endl;
        d_o[j].build();
    }

    /*for (long long i = 0; i < m; ++i) {
        for (long long j = 0; j < n; ++j) {
            cout << d_o[i].get_min(j, j) << ' ';
        }
        cout << endl;
    }*/
    long long minim = INF;
    for (long long i = 0; i < n; ++i) {
        minim = min(minim, dp[i][m - 1]);
    }
    cout << minim << endl;
    return 0;
}
