#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define vi vector<int>
#define vll vector<ll>
#define pi pair<int, int>
#define pll pair<ll, ll>
#define vpll vector<pll>
#define vvll vector<vll>
#define vvpll vector<vpll>
#define vvi vector<vector<int>>
#define vvc vector<vector<char>>
#define vc vector<char>
#define vb vector<bool>
#define vpi vector<pair<int, int>>
#define vvb vector<vb>
#define vvpi vector<vector<pair<int, int>>>
#define ios ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr)
#define all(vec) (vec).begin(), (vec).end()
#define rall(vec) (vec).rbegin(), (vec).rend()
#define sq(n) ((n) * (n))

int dx[] = {-1, 0, 1, 0};
int dy[] = {0, 1, 0, -1};

const ll INF = 1e18, P = 31;
const int inf = 1e9 + 1;
const ll mod = 1e9 + 7;
int MAX_C = 26;

class DSU {
public:
    vi size, pre;
    int comps;

    explicit DSU(int n) {
        size.assign(n + 1, 1);
        pre.resize(n + 1);
        for (int i = 1; i <= n; i++) pre[i] = i;
        comps = n;
    }

    int get_pre(int a) {
        if (pre[a] != a) pre[a] = get_pre(pre[a]);
        return pre[a];
    }

    bool merge(int a, int b) {
        a = get_pre(a);
        b = get_pre(b);
        if (a == b) return false;
        if (size[a] < size[b]) swap(a, b);
        pre[b] = a;
        size[a] += size[b];
        comps--;
        return true;
    }
};

struct Node {
    ll min_val = INF, pushed_val = INF;
};

class SegmentTree {
private:
    vector<Node> tree;
    int n;

    void push(int i) {
        ll tmp = tree[i].pushed_val;
        tree[i * 2].min_val = min(tree[i * 2].min_val, tmp);
        tree[i * 2].pushed_val = min(tree[i * 2].pushed_val, tmp);
        tree[i * 2 + 1].min_val = min(tree[i * 2 + 1].min_val, tmp);
        tree[i * 2 + 1].pushed_val = min(tree[i * 2 + 1].pushed_val, tmp);
    }

    void upd(int i, int tl, int tr, int l, int r, ll val) {
        if (tl == l and tr == r) {
            tree[i].pushed_val = min(tree[i].pushed_val, val);
            tree[i].min_val = min(tree[i].min_val, val);
            return;
        }
        int tm = (tl + tr) / 2;
        push(i);
        if (r <= tm) upd(i * 2, tl, tm, l, r, val);
        else if (l > tm) upd(i * 2 + 1, tm + 1, tr, l, r, val);
        else {
            upd(i * 2, tl, tm, l, tm, val);
            upd(i * 2 + 1, tm + 1, tr, tm + 1, r, val);
        }
        tree[i].min_val = min(tree[i * 2].min_val, tree[i * 2 + 1].min_val);
    }

    ll get_min(int i, int tl, int tr, int l, int r) {
        if (tl == l and tr == r) return tree[i].min_val;
        int tm = (tl + tr) / 2;
        push(i);
        if (r <= tm) return get_min(i * 2, tl, tm, l, r);
        else if (l > tm) return get_min(i * 2 + 1, tm + 1, tr, l, r);
        else {
            return min(get_min(i * 2, tl, tm, l, tm),
                       get_min(i * 2 + 1, tm + 1, tr, tm + 1, r));
        }
    }

public:
    void upd(int l, int r, ll val) {
        if (l > r) return;
        upd(1, 0, n - 1, l, r, val);
    }

    ll get_min(int l, int r) {
        return get_min(1, 0, n - 1, l, r);
    }

    explicit SegmentTree(int size) {
        tree.resize(4 * size);
        n = size;
    }
};

int gcd(ll a, ll b){
    a = abs(a);
    b = abs(b);
    if (a > b) swap(a, b);
    int cnt = 0;
    while (a != 0){
        b %= a;
        swap(a, b);
        cnt++;
    }
    return cnt;
}

ll perebor(ll a, ll b, int type = 1, int depth = 0){
    cout << a << " " << b << "\n";
    if (depth == 5) return 2e9;
    if (a == 0 || b == 0) return 0;
    if (abs(a) % abs(b) == 0 || abs(b) % abs(a) == 0) {
        return 1;
    }
    ll res = 2e9;
    for (int k = -10; k <= 10; ++k) {
        if (type == 1) res = min(res, 1 + perebor(a + k * b, b, 3 - type, depth + 1));
        if (type == 2) res = min(res, 1 + perebor(a, b + k * a, 3 - type, depth + 1));
    }
    return res;
}

struct Person {
    ld x, y, v;
};

ld get_intersection(Person a, Person b, Person c) {
    // inf - в любое время
    // -inf - никогда
    // t - если один раз

    if (a.v == b.v and b.v == c.v) {
        if ((b.y - a.y) * (c.x - a.x) == (c.y - a.y) * (b.x - a.x)) return inf;
        return -inf;
    }

    ld top = c.y * (b.x - a.x) + a.y * (c.x - b.x) + b.y * (a.x - c.x);
    ld down = (b.y - a.y) * (c.v - a.v) - (c.y - a.y) * (b.v - a.v);
    if (down == 0) return -inf;
    if (top / down < 0) return -inf;
    return top / down;
}

void solve() {
    int n;
    cin >> n;
    vector<Person> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].x >> arr[i].v;
        arr[i].y = i;
    }

    int max_ans = -1;
    for (int first = 0; first < n; first++) {
        for (int second = first + 1; second < n; second++) {
            unordered_map<ld, int> cnt;
            int ok_guys = 0;
            for (int third = 0; third < n; third++) {
                if (third == first or third == second) continue;
                ld res = get_intersection(arr[first], arr[second], arr[third]);
                if (res == -inf) continue;
                if (res == inf) ok_guys++;
                else {
                    cnt[res]++;
                    max_ans = max(max_ans, cnt[res] + 2 + ok_guys);
                }
            }
        }
    }

    cout << max_ans << '\n';
}

mt19937 gen;

signed main() {
    cout.precision(20);
    ios;
    int t;
    t = 1;
  //  cin >> t;
    while (t--) {
        solve();
    }
}