#include <iostream>
#include <algorithm>
#include <functional>
#include <string>
#include <vector>
#include <deque>
#include <numeric>
#include <cmath>
#include <queue>
#include <set>
#include <list>
#include <stack>
#include <array>
#include "math.h"

#define FAST1 std::ios_base::sync_with_stdio(false);
#define FAST2 std::cin.tie(0);

using ull = unsigned long long;
using ll = long long;
using namespace std;

pair<ull, ull> nextSqr(ull A, ull sqrtA)
{
	return make_pair(A + sqrtA * 2 + 1, sqrtA + 1);
}

ull reverseNum(ull A) {
	string strA = to_string(A);
	reverse(strA.begin(), strA.end());
	return stoull(strA);
}

bool isSqr(ull A)
{
	double sqr = sqrt(A);
	return sqr == (ull)sqr;
}

int main()
{
	FAST1;
	FAST2;
	ull A0, B;
	cin >> A0 >> B;
	ull sqrtA = ceil(sqrt(A0));
	ull A = pow(sqrtA, 2);
	ull res = 0;
	while (A <= B)
	{
		if(A % 10 != 0 && isSqr(reverseNum(A)))
			++res;
		auto next = nextSqr(A, sqrtA);
		A = next.first;
		sqrtA = next.second;
	}
	cout << res;
	return 0;
}