﻿#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <deque>
#include <queue>
#include <algorithm>
#include <map>
#include <string>
#define int long long
using namespace std;

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

double binpow(double a, int n) { // a ^ n % m
    if (n == 0) return 1;
    if (n % 2 == 0) {
        double x = binpow(a, n / 2);
        return x * x;
    }
    else return a * binpow(a, n - 1);
}

int phi(int n) {
    int res = n;
    for (int p = 2; p * p <= n; ++p) {
        if (n % p == 0)
            res -= res / p;
        while (n % p == 0)
            n /= p;
    }
    if (n > 1)
        res -= res / n;
    return res;
}

vector<int> factorization(int n) {
    vector<int> p;
    for (int d = 2; d * 1ll * d <= n; ++d) {
        if (n % d == 0) p.push_back(d);
        while (n % d == 0) {
            n /= d;
        }
    }
    if (n > 1) {
        p.push_back(n);
    }
    return p;
}

struct Tree {
    int n;
    vector<int> t;

    void build(vector<int>& A) {
        n = 1; // размер массива в дереве отрезков
        while (n < A.size()) n *= 2;
        t.resize(n * 2);
        for (int i = n; i < (n + A.size()); ++i) {
            t[i] = A[i - n];
        }
        for (int i = (n - 1); i <= 1; --i) {
            t[i] = t[i * 2] + t[i * 2 + 1];
        }
    }

    void set(int ind, int value) {
        ind += n;
        t[ind] = value;
        ind /= 2;
        while (ind >= 1) {
            t[ind] = t[ind * 2] + t[ind * 2 + 1];
            ind /= 2;
        }
    }

    int getsum(int l, int r) {
        l += n;
        r += n;
        int sum = 0;
        for (; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) {
                sum += t[l];
                l++;
            }
            if (r % 2 == 0) {
                sum += t[r];
                r--;
            }
        }

        return sum;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    set<char> gl = { 'a', 'e', 'i', 'o', 'u' };

    int n; cin >> n;
    vector<string> s(n);
    vector<int> sl(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        int cnt = 0;
        bool isgl = false;
        for (int j = 0; j < s[i].size(); ++j) {
            if ((gl.find(s[i][j]) != gl.end()) && !isgl) {
                ++cnt;
                isgl = true;
            }
            else if ((gl.find(s[i][j]) == gl.end())) isgl = false;
        }
        sl[i] = cnt;
    }
    //for (int i = 0; i < n; ++i) cout << sl[i];
    //cout << (gl.find('b') != gl.end());

    int cnt = 0, sum = sl[0];
    for (int l = 0, r = 0; r < n;) {
        if (sum == 5) {
            int curs = 0, k;
            for (int j = r + 1; j < n; ++j) {
                curs += sl[j];
                if (curs >= 7) {
                    k = j;
                    break;
                }
            }
            if (curs != 7) {
                ++r;
                if (r == n) break;
                sum += sl[r];
                continue;
            }
            curs = 0;
            for (int j = k + 1; j < n; ++j) {
                curs += sl[j];
                if (curs >= 5) {
                    break;
                }
            }
            if (curs == 5) {
                ++cnt;
            }
            
            ++r;
            if (r == n) break;
            sum += sl[r];
            continue;
            
        }
        else if (sum > 5) {
            ++l;
            sum -= sl[l - 1];
        }
        else if (sum < 5) {
            ++r;
            if (r == n) break;
            sum += sl[r];
        }
    }

    cout << cnt;
}
