#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#include <iomanip>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;


ll get(vector<ll> &p, ll l, ll r) {
    if (l) return p[r] - p[l - 1];
    return p[r];
}


void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n, 0);
    vector<ll> p(n, 0);
    vector<vector<char>> ban(n, vector<char>(n, 0));
    for (ll i = 0; i < n; i++) {
        ll j = i;
        while (ban[j][i]) {
            j--;
        }
        cout << "? " << j + 1 << ' ' << i + 1 << endl;
        ll x, l, r;
        cin >> x >> l >> r;
        l--;
        r--;
        ban[l][r] = 1;
        if (i == j) {
            a[i] = x;
        } else {
            a[i] = x - get(p, j, i - 1);
        }
        p[i] += a[i];
        if (i) p[i] = a[i] + p[i - 1];
    }
    cout << "! " << endl;
    for (auto &x : a) {
        cout << x << ' ';
    }
}


int main() {
    solve();
    return 0;
}
