#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#include <iomanip>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<vector<pair<ll, char>>> graph_t;

const ll INF = 1e18;


void solve() {
    ll n, a, b;
    cin >> n >> a >> b;
    vector<ll> x(n), y(n);
    for (auto& r : x) {
        cin >> r;
    }
    for (auto& r : y) {
        cin >> r;
    }
    ll l = 0, r = 0;
    vector<char> u(n, 0);
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        if (x[i] >= y[i]) {
            u[i] = 0;
            l++;
            ans += x[i];
        } else {
            u[i] = 1;
            r++;
            ans += y[i];
        }
    }
    ll d = max(0ll, max(a - l, b - r));
    set<pair<ll, ll>> g;
    for (ll i = 0; i < n; i++) {
        g.insert({(!u[i] ? x[i] - y[i] : y[i] - x[i]), i});
    }
    auto it = g.begin();
    while(d--) {
        ans -= it->first;
        u[it->second] = !u[it->second];
        it = next(it);
    }
    cout << ans << '\n';
    for (auto r : u) {
        if(r) {
            cout << "P ";
        } else {
            cout << "T ";
        }
    }
}


int main() {
    solve();
    return 0;
}
