#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

const ll maxn =  1e5;
const ld eps = 1e-10;

void bfs(ll s, vector <vector <ll>>& gr, vector <char>& used, vector <ll>& dp, vector <ll>& a) {
    queue<ll> q;
    q.push(s);
    used[s] = 1;
    while (!q.empty()) {
        ll v = q.front();
        q.pop();
        for (auto to: gr[v]) {
            ll k = (dp[v] > a[to] ? dp[v] : dp[v] / 2);
            if (!used[to] || dp[to] < k) {
                dp[to] = k;
                used[to] = 1;
                q.push(to);
            }
        }
    }
}

int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    vector <vector <ll>> gr(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u;
        cin >> v >> u;
        --v; --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    ll x; cin >> x;
    vector <ll> a(n);
    for (ll i = 0; i < n; ++i)
        cin >> a[i];
    vector <ll> dp(n);
    dp[0] = (x > a[0] ? x : x / 2);
    vector <char> used(n);
    bfs(0, gr, used, dp, a);
    cout << dp[n - 1];
}