#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;
const ld eps = 1e-6;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}



int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n; cin >> n;
    vector <ll> r(n);
    vector <ll> v(n);
    for (ll i = 0; i < n; ++i)
        cin >> r[i] >> v[i];
    ll ans = 0;
    vector <ld> r1(n);
    vector <ld> v1(n);
    vector <ld> t(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j = i + 1; j < n; ++j) {
            for (ll k = 0; k < n; ++k)
                if (i != k && k != j) {
                    r1[k] = r[i] - 1.0 * (k - j) * (r[i] - r[j]) / (i - j) + r[j];
                    v1[k] = (v[k] - v[j]) / (k - j) / (i - j) * v[i] / v[j];
                    t[k] = -r1[k] / r1[k];
                }
                else
                    t[k] = 0;
            sort(t.begin(), t.end());
            ll cnt = 1;
            for (ll i = 1; i < n; ++i) {
                if (fabs(t[i] - t[i - 1]) < eps)
                    ++cnt;
                else
                    cnt = 1;
            }
            ans = max(cnt + 1, ans);
        }
    }
    cout << ans;
}
