#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <random>
#include <functional>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

mt19937_64 rng(time(0));

//void kukarek() {
//    int a = rng() % INF + 1;
//    int b = rng() % INF + 1;
//}

int calc_euclid(int a, int b) {
    int cnt = 0;
    while (a && b) {
        cnt++;
        if (a < 0 && b < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    a += k * b;
                } else {
                    a += (k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    b += k * a;
                } else {
                    b += (k - 1) * a;
                }
            }
        } else if (a < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k + 1) * b)) {
                    a += k * b;
                } else {
                    a += (k + 1) * b;
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    b += k * a;
                } else {
                    b += (k - 1) * a;
                }
            }
        } else if (b < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    a += k * b;
                } else {
                    a += (k - 1) * b;
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k + 1) * a)) {
                    b += k * a;
                } else {
                    b += (k + 1) * a;
                }
            }
        } else {
            if (a > b) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    a += k * b;
                } else {
                    a += (k - 1) * b;
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    b += k * a;
                } else {
                    b += (k - 1) * a;
                }
            }
        }
    }
    return cnt;
}
void vost_euclid(int a, int b) {

    auto add = [&] (int type, int k) {
        cout << type << ' ' << k << '\n';
        if (type == 1) a += k * b;
        else b += k * a;
    };

    while (a && b) {
        if (a < 0 && b < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k - 1);
                }
            }
        } else if (a < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k + 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k + 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k - 1);
                }
            }
        } else if (b < 0) {
            if (abs(a) > abs(b)) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k + 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k + 1);
                }
            }
        } else {
            if (a > b) {
                int k = -a / b;
                if (abs(a + k * b) < abs(a + (k - 1) * b)) {
                    add(1, k);
                } else {
                    add(1, k - 1);
                }
            } else {
                int k = -b / a;
                if (abs(b + k * a) < abs(b + (k - 1) * a)) {
                    add(2, k);
                } else {
                    add(2, k - 1);
                }
            }
        }
    }
}

void solve() {
    int x, y;
    cin >> x >> y;

    vector<pair<int, int>> res;

    map<pair<int, int>, int> d, u;
    map<pair<int, int>, pair<int, int>> p;

    queue<pair<int, int>> q;
    u[{x, y}] = 1;
    d[{x, y}] = 0;
    p[{x, y}] = {-INF - 1, -INF};
    q.push({x, y});

    while (!q.empty()) {
        auto [a, b] = q.front();
        q.pop();
        if (a == 0 || b == 0) {
            cout << d[{a, b}] << '\n';
            vector<pair<int, int>> ans;
            while (p[{a, b}].first != -INF - 1) {
                if (p[{a, b}].first == a) {
                    res.emplace_back(2, (b - p[{a, b}].second) / a);
                    b = p[{a, b}].second;
                } else {
                    res.emplace_back(1, (a - p[{a, b}].first) / b);
                    a = p[{a, b}].first;
                }
            }
            reverse(res.begin(), res.end());
            for (auto &x : res) cout << x.f << ' ' << x.s << '\n';
            return;
        }
        if (a > 0 && b > 0) {
            if (d[{a, b}] + calc_euclid(a, b) <= 50) {
                cout << d[{a, b}] + calc_euclid(a, b) << '\n';
                int aa = a, bb = b;
                vector<pair<int, int>> ans;
                while (p[{a, b}].first != -INF - 1) {
                    if (p[{a, b}].first == a) {
                        res.emplace_back(2, (b - p[{a, b}].second) / a);
                        b = p[{a, b}].second;
                    } else {
                        res.emplace_back(1, (a - p[{a, b}].first) / b);
                        a = p[{a, b}].first;
                    }
                }
                reverse(res.begin(), res.end());
                for (auto &x : res) cout << x.f << ' ' << x.s << '\n';
                vost_euclid(aa, bb);
                return;
            }
        }
        for (int k : {a / b, b / a, -a / b, -b / a}) {
            for (int add = -1; add <= 1; add++) {
                {
                    int aa = a + (k + add) * b;
                    int bb = b;
                    if (abs(aa) <= INF && abs(bb) <= INF && !u[{aa, bb}]) {
                        d[{aa, bb}] = d[{a, b}] + 1;
                        u[{aa, bb}] = 1;
                        p[{aa, bb}] = {a, b};
                        q.push({aa, bb});
                    }
                }
                {
                    int aa = a;
                    int bb = b + (k + add) * a;
                    if (abs(aa) <= INF && abs(bb) <= INF && !u[{aa, bb}]) {
                        d[{aa, bb}] = d[{a, b}] + 1;
                        u[{aa, bb}] = 1;
                        p[{aa, bb}] = {a, b};
                        q.push({aa, bb});
                    }
                }
            }
        }
    }
}

//450000000000001021
//900000000000000241

//900000000000000017
//900000000000000059
//900000000000000121
//900000000000000209
//900000000000000241

//900000000000000121
//450000000000000223
//450000000000000127
//450000000000000223
//450000000000000277
//450000000000000293
//450000000000000361
//450000000000000679
//450000000000000727
//450000000000000743
//450000000000000797
//450000000000000833
//450000000000000889
//450000000000001001
//450000000000001021

signed main() {
    fast();
    solve();
    return 0;
}
