#include <bits/stdc++.h>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
constexpr int INF = (numeric_limits<int>::max()) / 2;
constexpr long long INFLL = (numeric_limits<long long>::max()) / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a) {
        is >> i;
    }
    return is;
}

using ll = long long;

struct segtree {
    vector<ll> tree, a;
    int n;

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            tree[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = min(tree[2 * v + 1], tree[2 * v + 2]);
    }

    segtree(vector<ll> a) : a(a) {
        n = a.size();
        tree.resize(4 * n);
        build(0, 0, n);
    }

    ll get(int v, int l, int r, int li, int ri) {
        if (li >= r || l >= ri) {
            return INFLL;
        }
        if (li <= l && r <= ri) {
            return tree[v];
        }
        int m = (l + r) / 2;
        return min(get(2 * v + 1, l, m, li, ri), get(2 * v + 2, m, r, li, ri));
    }

    ll get(int li, int ri) {
        return get(0, 0, n, li, ri);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<ll>> dp(m, vector<ll>(n, INFLL));
    int sprev = -1, lprev = -1;
    for (int i = 0; i < m; ++i) {
        int s, t;
        cin >> s >> t;
        --s;
        int l = t - s;
        if (sprev == -1) {
            for (int j = 0; j <= n - l; ++j) {
                dp[i][j] = abs(s - j);
            }
        } else {
            segtree cur(dp[i - 1]);
            for (int j = 0; j <= n - l; ++j) {
                dp[i][j] = cur.get( max(0, j - lprev + 1), min(n, j + l)) + abs(s - j);
            }
        }
        sprev = s;
        lprev = l;
    }
    cout << *min_element(all(dp[m - 1]));
}