#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <stdint.h>

using namespace std;

vector<vector<uint64_t>> graph;
vector<bool> used;
vector<uint64_t> e;
uint64_t n, m;
uint64_t x;
uint64_t maxC = 0;

void dfs(uint64_t v, uint64_t c) {
	if (c <= e[v]) {
		c /= 2;
	}

	if (v == n - 1 && c > maxC) {
		maxC = c;
	}

	for (uint64_t u : graph[v]) {
		if (used[u]) {
			return;
		} else {
			used[u] = true;
			dfs(u, c);
			used[u] = false;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> n >> m;

	graph.resize(n);
	used.assign(n, false);
	e.resize(n);

	for (int i = 0; i < m; i++) {
		int f, s;
		cin >> f >> s;
		f--;
		s--;
		graph[f].push_back(s);
		graph[s].push_back(f);
	}

	cin >> x;

	for (int i = 0; i < m; i++) {
		cin >> e[i];
	}

	dfs(0, x);

	cout << maxC;

	return 0;
}