#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <cmath>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const ld EPS = 1e-8;

struct Run {
    int x, v;

    Run() {}
    Run(int x, int v) : x(x), v(v) {}
};

bool check(ll x1, ll y1, ll x2, ll y2) {
    return (x1 * y2 == x2 * y1);
}

ll cp(pll a, pll b) {
    return a.first * b.second - a.second * b.first;
}

ll gcd(ll a, ll b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

void solve() {
    int n;
    cin >> n;
    vector<Run> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].v;
    }
    int ans = 2;

    pll A = {1, 1}, B = {1, 0};
//    cout << cp(A, B) << endl;
//    return;

    for (int fir = 0; fir < n; ++fir) {
        for (int sec = fir + 1; sec < n; ++sec) {
            int now = 2;
            map<pll, int> time;
            for (int i = sec + 1; i < n; ++i) {
                ll x1 = a[fir].x, y1 = fir,
                   x2 = a[sec].x, y2 = sec,
                   x3 = a[i].x, y3 = i;
                pll vec_ab = {x2 - x1, y2 - y1},
                    vec_ac = {x3 - x1, y3 - y1};
                if (cp(vec_ab, vec_ac) == 0) {
                    x1 = a[fir].x + a[fir].v; y1 = fir,
                    x2 = a[sec].x + a[sec].v; y2 = sec,
                    x3 = a[i].x + a[i].v; y3 = i;
                    vec_ab = {x2 - x1, y2 - y1};
                    vec_ac = {x3 - x1, y3 - y1};
                    if (cp(vec_ab, vec_ac) == 0) {
                        ++now;
                        continue;
                    }
                    else {
                        time[{0, 1}];
                    }
                }
                else {
                    if (cp(vec_ab, vec_ac) < 0) {
                        ll v2 = a[sec].v - a[fir].v, v3 = a[i].v - a[fir].v;
                        x1 = 0; y1 = 0;
                        x2 = a[sec].x - a[fir].x; y2 = sec - fir;
                        x3 = a[i].x - a[fir].x; y3 = i - fir;
                        pll t {(y2 * x3 - x2 * y3), (v2 * y3 - v3 * y2)};
                        if (t.first * t.second > 0) {
                            time[t]++;
                        }
                    }
                    else {
                        ll v2 = a[sec].v - a[fir].v, v3 = a[i].v - a[fir].v;
                        x1 = 0; y1 = 0;
                        x2 = a[sec].x - a[fir].x; y2 = sec - fir;
                        x3 = a[i].x - a[fir].x; y3 = i - fir;
                        pll t {(y2 * x3 - x2 * y3), (v2 * y3 - v3 * y2)};
                        if (t.first * t.second > 0) {
                            time[t]++;
                        }
                    }
                }
            }
            int mx = 0;
            for (auto &i: time) {
                mx = max(mx, i.second);
            }
            ans = max(ans, now + mx);
        }
    }
    cout << ans << en;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}