﻿﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <numeric>

typedef long long ll;
typedef long double ld;
using ll = long long;
using ld = long double;

using namespace std;

struct el
{
    ll id, val;
};

struct compare
{
    bool operator()(const el& a, const el& b)const
    {
        return a.val > b.val;
    }
};


ll add(const ll& clone, const ll& droid)
{
    if (clone > droid)
    {
        return clone;
    }
    else
    {
        return clone / 2;
    }
}

int main() {

    ll col, edge; cin >> col >> edge;

    vector<vector<ll>> vc(col);

    for (ll i = 0; i < edge; ++i)
    {
        ll f, t; cin >> f >> t;
        --t; --f;
        vc[f].push_back(t);
        vc[t].push_back(f);
    }

    ll clone; cin >> clone;

    vector<ll> droid(col); for (ll& i : droid)cin >> i;

    ll start = 0;
    ll end = col - 1;


    vector<ll> alive(col, 0);
    alive[start] = clone;

    std::multiset<el, compare> q;
    q.insert({ start,add(clone,droid[start]) });

    while (!q.empty())
    {
        el tek = *q.begin();
        q.erase(q.begin());

        for (ll& i : vc[tek.id])
        {
            if (alive[i] < add(tek.val, droid[i]))
            {
                alive[i] = add(tek.val, droid[i]);
                q.insert({ i,alive[i] });
            }
        }
    }

    cout << alive[end];

    return 0;
}