#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cmath>
#include <algorithm>
#include <stack>
#include <map>
#include <iomanip>
#include <queue>


using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll BASE = 179;
const ld EPS = 0.00000001;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, m; cin >> n >> m;
    vector <vector <int>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    int x; cin >> x;
    vector <int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    vector <bool> used(n, false);
    vector <int> ans(n, 0);
    if (w[0] < x) ans[0] = x;
    else ans[0] = x / 2;
    priority_queue <pair<int, int>> q;
    q.push({ans[0], 0});
    while (!q.empty()) {
        pair <int, int> v = q.top();
        q.pop();
        used[v.second] = true;
        for (auto i : g[v.second]) {
            if (!used[i]) {
                if (w[i] < v.first) ans[i] = max(v.first, ans[i]);
                else ans[i] = max(v.first / 2, ans[i]);
                q.push({ans[i], i});
            }
        }
    }
    cout << ans[n - 1];
    return 0;
}