#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <queue>
#include <cmath>
#include <cstdlib>

#define fori(a, b) for(int i = a; i < b; ++i)
#define forj(a, b) for(int j = a; j < b; ++j)
#define fork(a, b) for(int k = a; k < b; ++k)
#define forn(n) for(int i = 0; i < n; ++i)
#define X first
#define Y second
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

vector<int> tree;
ll P = 1;

int tree_min(int l, int r, int L, int R, int idx){
    if (r <= L || l >= R) return 1e9;
    if (l <= L && R <= r) return tree[idx];
    return min(tree_min(l, r, L, (L + R) / 2, 2 * idx), tree_min(l, r, (L + R) / 2, R, 2 * idx + 1));
}

void build_tree(vector<int> &a){
    P = 1;
    while (P < a.size()) P *= 2;
    tree.clear();
    tree.resize(2 * P, 1e9);
    for (int i = P; i < a.size() + P; ++i) tree[i] = a[i - P];
    for (int i = P - 1; i > 0; --i) tree[i] = min(tree[2 * i], tree[2 * i + 1]);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int> > dp(n, vector<int>(m));
    vector<int> ss(m);
    vector<int> es(m);
    vector<int> ls(m);
    vector<int> vs(n);
    int s, t;
    forn(m){
	cin >> ss[i] >> es[i];
	ls[i] = es[i] - ss[i];
    }

    for (int i = 0; i < n - ls[0]; i++)
	vs[i] = abs(i - ss[0]);
    for (int i = n - ls[0]; i < n; i++)
	vs[i] = vs[i - 1];
    build_tree(vs);
    for (int j = 1; j < m; j++) {
	for (int i = 0; i < n - ls[j]; i++) {
	    vs[i] = abs(i - ss[j]) + tree_min(i - ls[j - 1], i + ls[j] + ls[j - 1], 0, P, 1);
	}
	for (int i = n - ls[j]; i < n; i++)
	    vs[i] = vs[i - 1];
	build_tree(vs);
    }
    cout << tree_min(0, n, 0, P, 1);

    return 0;
}