#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<fstream>
#include<algorithm>
#include<cmath>
#include<iomanip>

#define ll long long

using namespace std;

vector<vector<long long>> t;
vector<vector<long long>> a;

const long long INF = 4e18;

int ls(int v) {
	return 2 * v + 1;
}

int rs(int v) {
	return 2 * v + 2;
}

void build(int v, int l, int r, int i) {
	if (l + 1 == r) {
		t[i][v] = a[i][l];
		return;
	}
	int m = (l + r) / 2;
	build(ls(v), l, m, i);
	build(rs(v), m, r, i);
	t[i][v] = min(t[i][ls(v)], t[i][rs(v)]);
}

long long get(int v, int l, int r, int lq, int rq, int i){
	if (rq <= l || r <= lq) {
		return INF;
	}
	if (lq <= l && r <= rq) {
		return t[i][v];
	}
	int m = (l + r) / 2;
	return min(get(ls(v), l, m, lq, rq, i), get(rs(v), m, r, lq, rq, i));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> seg(m);
	vector<int> len(m);
	a.resize(m);
	t.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> seg[i].first >> seg[i].second;
		seg[i].first--;
		seg[i].second--;
		len[i] = seg[i].second - seg[i].first + 1;
	}
	for (int j = 0; j < m; ++j) {
		a[j].resize(n);
		for (int i = 0; i < seg[j].first; ++i) {
			a[j][i] = seg[j].first - i;
		}
		for (int i = seg[j].first; i <= seg[j].second; ++i) {
			a[j][i] = 0;
		}
		for (int i = seg[j].second + 1; i < n; ++i) {
			a[j][i] = i - seg[j].second;
		}
	}
	t[0].resize(4 * n);
	build(0, 0, n, 0);
	for (int i = 0; i < m - 1; ++i) {
		for (int j = 0; j < n; ++j) {
			a[i + 1][j] += a[i][j];
		}
		t[i + 1].resize(4 * n);
		build(0, 0, n, i + 1);
		for (int j = 0; j < n; ++j) {
			a[i + 1][j] = get(0, 0, n, max(0, j - len[i + 1] + 1), min(n, j + len[i + 1]), i + 1);
		}
	}
	cout << get(0, 0, n, 0, n, m - 1);
}


