import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class C {
    private static int[] tree;
    private static int[][] dp;
    private static final int MAX = Integer.MAX_VALUE;
    private static void build(int ind, int v, int tl, int tr) {
        if (tl==tr) tree[v] = dp[ind][tl];
        else {
            int mid = (tl + tr)/2;
            build(ind, v*2, tl, mid);;
            build(ind, v*2+1, mid+1, tr);
            tree[v] = Math.min(tree[v*2], tree[v*2+1]);
        }
    }

    private static int getMin(int v, int tl, int tr, int l, int r) {
        if (r<tl || tr<l) return MAX;
        if (l<=tl && tr<=r) return tree[v];
        int mid = (tl + tr)/2;
        return Math.min(getMin(v*2, tl, mid, l, r), getMin(v*2+1, mid+1, tr, l, r));
    }

    public static void main(String[] args) {
        Reader myReader = new Reader();
        int n = myReader.nextInt();
        int m = myReader.nextInt();
        dp = new int[m][n];
        int[] height = new int[m];
        for (int i=0; i<m; i++) {
            int l = myReader.nextInt() - 1, r = myReader.nextInt() - 1;
            int h = r - l + 1;
            height[i] = h;
            Arrays.fill(dp[i], MAX);
            for (int j=h-1; j<n; j++) {
                if (i==0) dp[i][j] = Math.abs(j - r);
                else {
                    int right = Math.min(n-1, j + height[i-1] - 1);
                    int left = Math.max(0, j - h + 1);
                    int minPrev = getMin(1, 0, n-1, left, right);
                    int minDiff = Math.abs(j - r);
                    dp[i][j] = minPrev + minDiff;
                }
            }
            tree = new int[n*4+4];
            Arrays.fill(tree, MAX);
            build(i, 1, 0, n-1);
        }
        int res = MAX;
        for (int i=0; i<n; i++) {
            res = Math.min(res, dp[m-1][i]);
        }
        System.out.println(res);
    }

    static class Reader {
        BufferedReader reader;
        StringTokenizer st;

        Reader() {
            reader = new BufferedReader(new InputStreamReader(System.in));
        }

        String nextToken() {
            try {
                if (st==null || !st.hasMoreElements()) st = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }
        long nextLong() { return Long.parseLong(nextToken());}
    }
}
