#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <set>




using namespace std;


const long long inf = -1e10;

vector<long long> dist;

bool cmp(int v, int u){
    return (dist[v] > dist[u] || (dist[v] == dist[u] && v > u));
}


int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(16);


    long long n, m;

    cin >> n >> m;


    vector<vector<long long>> gr(n);

    for (int i = 0; i < m; i++){
        long long v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].push_back(u);
        gr[u].push_back(v);

    }

    long long x;

    cin >> x;

    vector<long long> clon(n);

    for (int i = 0; i < n; i++){
        cin >> clon[i];
    }

    dist.assign(n, inf);

    if (x > clon[0]) dist[0] = x;
    else{
        dist[0] = x / 2;

    }
    

    

    set<long long, decltype(&cmp)> st(cmp);

    st.insert(0);

    while(!st.empty()){
        int v = *st.begin();

        //cout << v << " ";
        st.erase(st.begin());
        for (auto u: gr[v]){
            long long buf = dist[v];
            
            if (buf <= clon[u]) buf /= 2;
            if (dist[u] < buf){
                st.erase(u);
                dist[u] = buf;
                st.insert(u);
            }
        }
    }

    cout << dist[n - 1];



    

    






    

    return 0;  




}