#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector <int> droids(n);
    vector <int> dist(n, 35);
    vector <vector <int>> g(n);

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;

        --u, --v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }

    int have;
    cin >> have;

    for (auto &i : droids) {
        cin >> i;
    }

    dist[0] = (have <= droids[0]);
    deque <int> q;
    q.push_back(0);
    vector <bool> used(n);

    while (!q.empty()) {
        int v = q.front();
        q.pop_front();

        if (used[v]) {
            continue;
        }

        for (auto &i : g[v]) {
            if (!used[i] && dist[i] > dist[v] + ((have >> dist[v]) <= droids[i])) {
                dist[i] = dist[v] + ((have >> dist[v]) <= droids[i]);

                if (dist[i] == dist[v]) {
                    q.push_front(i);
                }
                else {
                    q.push_back(i);
                }
            }
        }
    }

    cout << (have >> dist[n - 1]);

    return 0;
}