import kotlin.math.absoluteValue
import kotlin.math.roundToLong

const val ONLINE_JUDGE = true //I'm not sure if it exists

fun main() {
    if (!ONLINE_JUDGE) {
        System.setIn(
            (
                    "15\n" +
                            "if\n" +
                            "the\n" +
                            "real\n" +
                            "beauties\n" +
                            "of\n" +
                            "sunset\n" +
                            "in\n" +
                            "a\n" +
                            "suspended\n" +
                            "moment\n" +
                            "call\n" +
                            "for\n" +
                            "the\n" +
                            "thunder\n" +
                            "forever"
                    ).byteInputStream()
        )
    }

    solveH()
}

fun solveH() {
    var (a, b) = longArr()
    val res = mutableListOf<Pair<Int, Long>>()

    fun apply1(k: Long) {
        res.add(1 to k)
        a += k * b
    }

    fun apply2(k: Long) {
        res.add(2 to k)
        b += k * a
    }

    while (a != 0L && b != 0L) {
        if (a.absoluteValue < b.absoluteValue) {
            val k = divide(b.absoluteValue, a.absoluteValue)
            when {
                a < 0 && b < 0 -> apply2(-k)
                a < 0 && b > 0 -> apply2(k)
                a > 0 && b < 0 -> apply2(k)
                a > 0 && b > 0 -> apply2(-k)
            }
        } else {
            val k = divide(a.absoluteValue, b.absoluteValue)
            when {
                a < 0 && b < 0 -> apply1(-k)
                a < 0 && b > 0 -> apply1(k)
                a > 0 && b < 0 -> apply1(k)
                a > 0 && b > 0 -> apply1(-k)
            }
        }
    }

    println(res.size)
    for (pair in res) println("" + pair.first + " " + pair.second)
}

//Assuming a & b are positive
fun divide(a: Long, b: Long): Long = if (a % b == 0L) a / b else (a.toDouble() / b).roundToLong()

fun solveE() {
    val n = int()

    fun String.countUnits(): Int {
        var units = 0
        var vowels = -1
        for (c in toCharArray())
            if (c == 'a' || c == 'i' || c == 'o' || c == 'u' || c == 'e') {
                vowels++
            } else {
                if (vowels != -1) units++
                vowels = -1
            }
        if (vowels != -1) units++
        return units
    }

    val words = List(n) { line().countUnits() }
    var haikus = 0

    println(haikus)
}

fun solveD() {
    val (v, e) = intArr()
    val neighbors = List(v) { mutableListOf<Int>() }
    repeat(e) {
        val (a, b) = intArr()
        neighbors[a - 1].add(b - 1)
        neighbors[b - 1].add(a - 1)
    }

    val x = int()
    val droids = intArr()

    val cameWith = IntArray(v)
    cameWith[0] = if (x > droids[0]) x else x / 2

    fun dfs(i: Int) {
        val was = cameWith[i]
        for (nei in neighbors[i]) {
            val became = if (was > droids[nei]) was else was / 2
            if (became > cameWith[nei]) {
                cameWith[nei] = became
                if (i != v - 1) dfs(nei)
            }
        }
    }

    dfs(0)
    println(cameWith.last())
}

fun solveB() {
    val n = int()
    val arr = MutableList<Long?>(n) { null }
    val banned = List(n) { mutableListOf<Int>() }

    var index = 0
    val pref = mutableListOf<Long>(0)
    while (index != n) {
        for (i in 0..index) {
            if (index in banned[i]) continue
            println("? ${i + 1} ${index + 1}")
            val slbrb = longArr()
            val s = slbrb[0]
            val lb = slbrb[1].toInt()
            val rb = slbrb[2].toInt()
            arr[index] = s - (pref[index] - pref[i])
            banned[lb - 1].add(rb - 1)
            banned[rb - 1].add(lb - 1)
            pref.add(pref.last() + arr[index]!!)
            break
        }
        index += 1
    }
    println("!")
    println(arr.joinToString(" "))

}

fun solveA() {
    val (r, c, n) = intArr()
    if (n > r || n > c) return println("Impossible")
    println("Possible")
    val line = ".".repeat(c)
    if (r < c) {
        for (i in 0 until n) println(".".repeat(i) + "*" + ".".repeat(c - i - 1))
    } else {
        for (i in 0 until n) println(".".repeat(i) + "*" + ".".repeat(c - i - 1))
    }
    repeat(r - n) { println(line) }
}

fun line() = readLine()!!
fun int() = readLine()!!.trim().toInt()
fun long() = readLine()!!.trim().toLong()
fun intArr() = readLine()!!.trim().split(" ").mapNotNullTo(mutableListOf()) { if (it == "") null else it.toInt() }
fun longArr() = readLine()!!.trim().split(" ").mapNotNullTo(mutableListOf()) { if (it == "") null else it.toLong() }
fun intArr2(rows: Int) = List(rows) { intArr() }