#include <bits/stdc++.h>

using namespace std;

struct sparse{
    const int lg = 30;
    vector<vector<int>> arr;
    vector<int> log;

    void build(int n, vector<int> v){
        arr.resize(lg);
        log.resize(n+1);
        for (int i = 2; i <= n; ++i) log[i] = log[i/2] + 1;
        for (int i = 0; i < lg; ++i) arr[i].resize(n+1);

        for (int i = 1; i <= n; ++i) arr[0][i] = v[i];

        for (int i = 1; i < lg; ++i){
            for (int j = 1; j <= n; ++j){
                arr[i][j] = arr[i-1][j];
                if (j + (1 << (i-1)) <= n) arr[i][j] = min(arr[i][j], arr[i-1][j + (1 << (i-1))]);
            }
        }
    }

    int getmin(int n, int l, int r){
        l = max(l, 1); r = min(r, n);
        int k = log[r - l + 1];
        return min(arr[k][l], arr[k][r - (1 << k) + 1]);
    }
};

int main() {
    int n, m; cin >> n >> m;
    vector<int> s(m+1), t(m+1);
    for (int i = 1; i <= m; ++i) cin >> s[i] >> t[i];

    vector<int> sz(m+1);
    for (int i = 1; i <= m; ++i) sz[i] = t[i] - s[i];

    vector<vector<int>> dp(m+1, vector<int>(n+1, 1000000000));
    dp[0].assign(n+1, 0);

    sparse sp;
    sp.build(n, dp[0]);

    for (int i = 1; i <= m; ++i){
        for (int j = 1; j <= n; ++j){
            if (j + sz[i] > n) break;
            dp[i][j] = sp.getmin(n, j - sz[i-1] , j + sz[i]) + abs(s[i] - j);
        }
        sp.build(n, dp[i]);
    }

    int ans = 1000000000;
    for (int i = 1; i <= n; ++i) ans = min(ans, dp[m][i]);
    cout << ans << "\n";

    return 0;
}
