#if 1  

#define DEBUG 0

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#if DEBUG
int runs = 1;
ifstream input("ProblemA/in.txt");
ofstream output("ProblemA/out.txt");
#else
int runs = 1;
istream& input = std::cin;
ostream& output = std::cout;
#endif

const int INF = (int)1e9;

struct Edge
{
	int v;
};

struct Vert
{
	bool isVis;
	int clons;
	int droids;
};


struct Graph
{
	int nofVert;
	vector<vector<Edge>> node;
	vector<Vert> vert;

	Graph(int N) : nofVert(N),
		node(N), vert(N, {false, -INF})
	{

	}

	void addEdge(int v1, int v2)
	{
		node[v1].push_back({ v2 });
		node[v2].push_back({ v1 });
	}


	void dkstra(int s, int n)
	{
		int v = s;
		vert[v].clons = (n > vert[v].droids ? n : n / 2);
		while (vert[v].isVis == false)
		{
			vert[v].isVis = true;


			for (Edge& edge : node[v])
			{
				int newClons = (vert[v].clons > vert[edge.v].droids ? vert[v].clons : vert[v].clons / 2);
				if (vert[edge.v].clons < newClons)
					vert[edge.v].clons = newClons;
			}

			int maxClons = -INF;
			for (int i = 0; i < nofVert; i++)
			{
				if (vert[i].isVis == false && maxClons < vert[v].clons)
				{
					v = i;
					maxClons = vert[v].clons;
				}
			}
		}
	}

};

int main()
{
	while (runs-- > 0)
	{
		int N, M;
		input >> N >> M;

		Graph gr(N);
		for (int i = 0; i < M; i++)
		{
			int v1, v2;
			input >> v1 >> v2;
			v1--;
			v2--;

			gr.addEdge(v1, v2);
		}

		int x;
		input >> x;

		for (int i = 0; i < N; i++)
			input >> gr.vert[i].droids;

		gr.dkstra(0, x);
		if (gr.vert[N - 1].clons == -INF)
			output << 0;
		else
			output << gr.vert[N - 1].clons << endl;

	

	}
	return 0;
}




#endif 
