#include <algorithm>
#include <math.h>
#include <iostream>
#include <vector>
#include <set>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<double> vd;

ll reverse(ll x)
{
	int a = 0;

	while (x != 0)
	{
		a *= 10;
		a += x % 10;
		x /= 10;
	}
	return a;
}

void solveJ()
{
	ll a, b;
	cin >> a >> b;

	ll min = static_cast<int>(sqrt(a)), max = static_cast<int>(sqrt(b));
	set<ll> res;
	for (ll i = min; i <= max; i++)
	{
		if (i * i % 10 == 0)
			continue;
		ld x = sqrt(static_cast<ld>(reverse(i * i)));
		ll y = static_cast<int>(x);
		if (x == y && i * i >= a && i * i <= b)
		{
			res.insert(i * i);
		}
	}
	cout << res.size() << '\n';
}

void solveA()
{
	int n, m, k;
	cin >> n >> m >> k;

	if (k > n || k > m)
	{
		cout << "Impossible\n" << endl;
		return;
	}
	cout << "Possible\n";

	for (int i = 0, cnt = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (i == j && cnt < k)
			{
				cout << "*";
				cnt++;
			}
			else
				cout << ".";
		}
		cout << "\n";
	}

}

/*void solveE()
{
	vector<string> wrds;
	vi sls;
	int n;

	cin >> n;
	for (int i = 0; i < n; i++)
	{
		string a;
		cin >> a;
		wrds.push_back(a);
	}
	int wrds_c = wrds.size();

	for (unsigned int i = 0; i < wrds_c; i++)
	{
		int sl = 0;
		bool prev_a = false;
		for (auto ch : wrds[i])
		{
			if (ch == 'a' || ch == 'e' || ch == 'i' || ch == 'o' || ch == 'u')
			{
				if (!prev_a)
					sl++;
				prev_a = true;

			}
			else prev_a = false;
		}
		sls.push_back(sl);
	}
	int sls_c = sls.size();

	int hok = 0;
	for (unsigned int i = 0; i < wrds_c; i++)
	{
		int sl_str = 0, j = i;
		while (sl_str < 5 && j < sls_c)
			sl_str += sls[j++];
		if (sl_str != 5)
			continue;
		sl_str = 0;

		while (sl_str < 7 && j < sls_c)
			sl_str += sls[j++];
		if (sl_str != 7)
			continue;
		sl_str = 0;

		while (sl_str < 5 && j < sls_c)
			sl_str += sls[j++];
		if (sl_str != 5)
			continue;
		
		hok++;
	}
	cout << hok;
}*/

void solveI()
{
	int n, a, b, res = 0;
	cin >> n >> a >> b;
	vi ai(n);
	vi bi(n);
	vector<pair<int, int>> di(n);
	vector<char> ri(n, 'P');

	for (int i = 0; i < n; i++)
		cin >> ai[i];
	for (int i = 0; i < n; i++)
	{
		cin >> bi[i];
		di[i] = { bi[i] - ai[i], i };
		res += bi[i];
	}

	sort(di.begin(), di.end(), [](std::pair<int, int> a, std::pair<int, int> b) { return a.first < b.first; });

	for (int i = 0; i < a; i++)
	{
		res -= di[i].first;
		ri[di[i].second] = 'T';
	}
	for (int i = a; i < n - b; i++)
		if (di[i].first < 0)
		{
			res -= di[i].first;
			ri[di[i].second] = 'T';
		}

	cout << res << '\n';
	for (auto i : ri)
		cout << i << ' ';
	cout << endl;
}


vi used;
vi droids;
vector<vector<int>> ways;

void fight(int clones, int at)
{
	int cf = clones > droids[at] ? clones : clones / 2;

	if (used[at] < cf)
	{
		used[at] = cf;
		int s = ways[at].size();
		for (int i = 0; i < s; i++)
			if (at != ways[at][i])
				fight(cf, ways[at][i]);
	}
}

void solveD()
{
	int n, m, clones;
	cin >> n >> m;
	ways.resize(n);
	droids.resize(n);
	used.resize(n, -1);


	for (int j = 0; j < m; j++)
	{
		int a, b;
		cin >> a >> b;
		ways[a - 1].push_back(b - 1);
		ways[b - 1].push_back(a - 1);
	}
	cin >> clones;

	for (int i = 0; i < n; i++)
		cin >> droids[i];
	fight(clones, 0);
	cout << used[n - 1] << endl;
}

int main()
{
	solveD();
	return 0;
}