#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

const int MXV = 1000001;
inline void solve() noexcept {
    int n, m;
    cin >> n >> m;
    vector<pii> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].first, --a[i].second;
    }

    vector<vector<int>> dp(m, vector<int>(n, MXV));
    for (int i = 0; i < n; ++i)
        dp[0][i] = abs(i - a[0].first);
        
    for (int i = 1; i < m; ++i) {
        int lb = 0, rb = a[i].second - a[i].first;
        multiset<int> req;

        for (int j = lb; j <= rb; ++j)
            req.insert(dp[i - 1][j]);

        dp[i][0] = *req.begin() + a[i].first;
        for (int nj = 1; nj < n; ++nj) {
            int nlb = max(0LL, nj - a[i - 1].second + a[i - 1].first);
            int nrb = min(n - 1, nj + a[i].second - a[i].first);

            for (int p = lb; p < nlb; ++p)
                req.erase(req.find(dp[i - 1][p]));

            for (int p = rb + 1; p <= nrb; ++p)
                req.insert(dp[i - 1][p]);

            dp[i][nj] = *req.begin() + abs(nj - a[i].first);
            lb = nlb, rb = nrb;

            // cerr << "\ni: " << i << " nj: " << nj << '\n';
            // for (auto en : req) {
            //     cerr << en << ' ';
            // }

            // cerr << '\n';
        }
    }

    // cerr << "\nDP IS ---------------\n";
    // forn(i, m) {
    //     forn(j, n) {
    //         cerr << dp[i][j] << ' ';
    //     }

    //     cerr << '\n';
    // }
    // cerr << "END DP------------\n";

    int ans = MXV;
    for (int j = 0; j < n; ++j)
        ans = min(ans, dp[m - 1][j]);
    cout << ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio();
    int tt = 1;
    // cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
