#include <algorithm>
#include <cassert>
#include <cmath>
#include <iomanip>
#include <ios>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <string>
#include <unordered_map>
#include <utility>
#include <vector>
using namespace std;

#define int long long

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define pb push_back
using ll = long long;
using db = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

void fastio() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    cin.exceptions(ios::failbit);
}

string gl = "auioe";

int count_sl(const string& s) { 
    vector<int> pos;
    forn(i, sz(s)) {
        if (gl.find(s[i]) != string::npos) pos.pb(i);
    }

    int cnt = 0;
    pos.pb(1e9);
    forn(i, sz(pos) - 1) if (pos[i] + 1 != pos[i + 1]) cnt++;
    return cnt;
}

int check(int l, int r, vector<int>& w) {
    int sm1 = 0, sm2 = 0;

    for (int i = l; i < r; ++i) {
        sm1 += w[i];
        if (sm1 > 5) return 0;
        if (sm1 == 5) break;
    }

    for (int i = l; i < r; ++i) {
        sm2 += w[i];
        if (sm2 > 7) return 0;
        if (sm2 == 7) break;
    }

    return 1;
}

inline void solve() noexcept {
    int n;
    cin >> n;

    vector<int> words;

    forn(i, n) {
        string w;
        cin >> w;

        if (count_sl(w) == 0) continue;
        words.pb(count_sl(w));
    }
    n = sz(words);

    int ans = 0;
    forn(l, n) {
        int sum = words[l];
        for (int r = l; r < n; ++r) {
            if (sum == 17) {
                ans += check(l, r, words);
                break;
            }
            sum += words[r];
            if (sum > 17) break;
        }
    }

    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio();
    int tt = 1;
    // cin >> tt;
    while (tt-- > 0)
        solve();
    return 0;
}
