#include <iostream>
#include <deque>
#include <utility>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
using namespace std;

struct line
{
    long double k, b;
};

long double get(line a, long double x)
{
    return a.k * x + a.b;
}

long double cross(line a, line b, bool& ok)
{
    if(a.k == b.k)
    {
        ok = 0;
        return 0.0;
    }
    ok = 1;
    return (a.b - b.b) / (a.k - b.k);
}

int main() 
{
    int n, answer = 0; cin>>n;
    vector<pair<long double, long double> > arr(n);
    for(int i = 0; i < n; i++) cin>>arr[i].first>>arr[i].second;
    for(int i = 0; i < n; i++)
    {
        map<pair<long double, long double>, int> ans;
        vector<line> tmp;
        for(int j = 0; j < n; j++)
            if(i != j)
                tmp.push_back({(arr[i].second - arr[j].second) / (j - i), (arr[i].first - arr[j].first) / (j - i)});
        for(int i = 0; i < n - 1; i++)
        {
            for(int j = 0; j < n - 1; j++)
            {
                if(i != j)
                {   
                    bool ok;
                    long double t = cross(tmp[i], tmp[j], ok);
                    if(ok)  ans[{t, get(tmp[i], t)}]++;                   
                }
            }   
        }
        for(auto i: ans) answer = max(answer, 1 + (int)((1 + sqrt(1 + 8 * i.second)) / 2));
    }
    cout<<answer;
    return 0;
}