// Egor Yukhnevich
#include <bits/stdc++.h>
#include <unordered_set>
#include <unordered_map>
using namespace std;

using u8 = uint8_t;
using u16 = uint16_t;
using u32 = uint32_t;
using u64 = uint64_t;

using s8 = int8_t;
using s16 = int16_t;
using s32 = int32_t;
using s64 = int64_t;

using ld = long double;

/*
* GLOBAL PROJECT SETTINGS
*/

//#define HOME_MODE

//#define DEBUG
//#define MULTITEST
//#define STRESS_TEST // включает HOME_MODE, MULTITEST и тестирует решения

//#define TASK_FILE_NAME "pnumbers" // если есть, включает файловый ввод и вывод

/*
* SIMULATE SETTINGS
*/

#ifdef TASK_FILE_NAME
#define FILE_INPUT TASK_FILE_NAME".in"
#define FILE_OUTPUT TASK_FILE_NAME".out"
#endif

#ifdef STRESS_TEST
#define HOME_MODE // стресс-тест бывает только дома
#define MULTITEST // у нас есть несколько тестов для тестирования
#endif

#ifdef HOME_MODE
#undef FILE_INPUT
#undef FILE_OUTPUT
#define FILE_INPUT "input.txt"
#else
#undef DEBUG
#endif

/*
* SOLVE PROBLEM
*/

s64 rev(s64 n){
    s64 x = 0;
    while(n){
        x = x * 10 + n % 10;
        n /= 10;
    }
    return x;
}

bool is_kv(s64 x){
    return s64(sqrt(x)) * s64(sqrt(x)) == x;
}

void solve(istream& cin, ostream& cout) {
    s64 l, r;
    cin >> l >> r;

    s64 res = 0;
    for(s64 x = 1; x * x <= r; x++){
        s64 val = x * x;

        if(val % 10 != 0 && val >= l && is_kv(rev(val))){
            res++;
            //cout << val << "\n";
        }
    }
    cout << res << "\n";
}


void main_build() {

}

void correct_solve(istream& cin, ostream& cout) {

}

#ifdef STRESS_TEST

#include <random>
mt19937_64 rnd(42);

// строит тест
string build_test() {
    stringstream out;

    // вывести тест

    return out.str();
}

#endif


/*
* TEMPLATE MAIN
*/

int main() {
    //setlocale(LC_ALL, "Russian");
#ifdef FILE_INPUT
    ifstream cin(FILE_INPUT);
#endif
#ifdef FILE_OUTPUT
    ofstream cout(FILE_OUTPUT);
#endif
    ios::sync_with_stdio(false), cout.tie(nullptr), cin.tie(nullptr);

    main_build();

    s64 t = 1;
#ifdef MULTITEST
    cin >> t;
#endif

    while (t--) {
#ifdef STRESS_TEST
        string test_str_input = build_test(); // создаем тест

        stringstream input1 = stringstream(test_str_input);
        stringstream input2 = stringstream(test_str_input);

        // получаем ответы на тест
        stringstream wrong_out, correct_out;
        solve(input1, wrong_out);
        correct_solve(input2, correct_out);

        // сравниваем их
        if (wrong_out.str() != correct_out.str()) {
            cout << "[failed test]\n" << test_str_input << "\n";

            cout << "[wrong output]\n" << wrong_out.str() << "\n";

            cout << "[correct output]\n" << correct_out.str() << "\n";

            return 0;
        }
#else
        solve(cin, cout);
#endif
    }

#ifdef STRESS_TEST
    cout << "[all tests passed]\n";
#endif

    return 0;
}
